-- Captain's Kit v1.0
-- By AbortRetryFail

declare("Ckit", {})
Ckit.gunners = {} -- Keeps current state of turret gunners.

-- Local variables
local holdfire = false
local hudchat = true
local gunners = Ckit.gunners
local shipstations = 
	{
		-- Only ship station types with docking bays need to go here.
		["Trident Type M"] = true,
	}

-- Local functions and shortcuts
local function shipchat(msg) return SendChat(msg, "STATION") end
local function psm(msg) return HUD.PrintSecondaryMsg(HUD, msg) end
local function iscapship() 
	-- This exists because GetCurrentStationType() does not return 1 for the capship pilot. Blah.
	local stype = GetStationType()
	return stype and shipstations[stype] or false
end

-- Event handlers
function Ckit:TURRET_OCCUPIED(event, turretindex, charid)
	gunners[turretindex] = charid
	if holdfire then
		Gunner.Dismiss(GetPlayerName(charid))
	end
end

function Ckit:TURRET_EMPTY(event, turretindex, charid)
	if gunners[turretindex] then
		table.remove(gunners, turretindex)
	end
end

function Ckit:CHAT_MSG_BARENTER(event, args)
	if hudchat and iscapship() then
		local charname = string.match(args.msg, "(.-) has entered the room.")
		psm(charname.." docked.")
	end
end

function Ckit:CHAT_MSG_BARLEAVE(event, args)
	if hudchat and iscapship() then
		local charname = string.match(args.msg, "(.-) has left the room.")
		psm(charname.." undocked.")
	end
end

RegisterEvent(Ckit, "TURRET_OCCUPIED")
RegisterEvent(Ckit, "TURRET_EMPTY")
RegisterEvent(Ckit, "CHAT_MSG_BARENTER")
RegisterEvent(Ckit, "CHAT_MSG_BARLEAVE")

-- User Commands
function Ckit.holdfire()
	local msg = ""
	holdfire = not holdfire
	if holdfire then
		msg = "All gunners, hold your fire."
		for turretindex, charid in pairs(gunners) do
			Gunner.Dismiss(GetPlayerName(charid))
		end
	else
		msg = "All gunners, report to battle stations."
	end
	shipchat(msg)
	psm(msg)
end

RegisterUserCommand("holdfire", Ckit.holdfire)
